#include "all.h"


void qsort(vector<char> & array,int begin,int end)
{
	vector<int> mystk;
	int q;

START:
	if(end <= begin)
		goto RETURN;

	q = partition(array,begin,end);

	mystk.push_back(q);
	mystk.push_back(begin);
	mystk.push_back(end);
	end = q -1;
	goto START;

RETURN:
	if(mystk.size() == 0)
		return;

	end = mystk[mystk.size() - 1];
	mystk.pop_back();
	begin = mystk[mystk.size() - 1];
	mystk.pop_back();
	q = mystk[mystk.size() - 1];
	mystk.pop_back();

	begin = q + 1;
	goto START;
}


int partition(vector<char> & array,int begin,int end)
{
	char x = array[begin];
	int i = begin - 1;
	int j = end + 1;

	while(true)
	{
		do
		i++;
		while(array[i] <= x && i < j);

		do
		j--;
		while(array[j] > x && i < j);

		if(i < j)
			swap(array[i],array[j]);
		else
		{
			swap(array[begin],array[i - 1]);
			return i - 1;
		}
	}
}